/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-21 17:35
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N, A, B;

vector<int> used;

vector<int> edges[MAXN], cycle;
vector<int> target;

ll start;
bool dfs_cycle(int u, int p = -1){
    used[u] = 1;
    for(auto w : edges[u]){
        if(w == p) continue;
        if(used[w]){
            start = w;
            cycle.push_back(u);
            return 1;
        }
        else{
            if(dfs_cycle(w, u)){
                cycle.push_back(u);
                return 1;
            }
        }
    }
    return 0;
}

ll point;
ll dfs_find(int u, int p = -1, int de = 0){
    if(target[u]) return point = u, de;
    ll m = INF;
    for(auto w : edges[u]){
        if(w == p) continue;
        m = min(m, dfs_find(w, u, de + 1));
    }
    return m;
}

void solve(){
    // Code goes here ...
    cin >> N >> A >> B;

    vector<pii> es(N);
    int u, v;
    R(i, N){
        cin >> u >> v;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }

    used = vector<int>(N + 1, 0);
    start = -1;
    dfs_cycle(1);
    
    vector<int> loop;
    for(auto e : cycle){
        loop.push_back(e);
        if(e == start) break;
    }
    target = vector<int>(N + 1);
    for(auto e : loop) target[e] = 1;

    ll b_dist = dfs_find(B);
    target = vector<int>(N + 1);
    target[point] = 1;
    ll a_dist = dfs_find(A);

    /* cout << "Start: " << start << endl; */
    /* for(auto e : cycle) cout << e << " "; cout << endl; */
    /* for(auto e : loop) cout << e << " "; cout << endl; */

    // cleanup
    R(i, N + 2) edges[i].clear();
    cycle.clear();

    if(B == A){
        cout << "NO" << endl;
        return;
    }

    cout << (b_dist < a_dist ? "YES" : "NO") << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
